@Echo off
setlocal enabledelayedexpansion
title Add to Self Radio - Settings editor
color 8F
:menu
:: Read settings from registry
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Mode"') do (
	set currMode=%%A
)
if "!currMode!"=="" (
	set currMode=UNDEFINED
)
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Ignore"') do (
	set currIgnore=%%A
)
if "!currIgnore!"=="" (
	set currIgnore=UNDEFINED
)
if !currIgnore!==0 (
	set currIgnore=FALSE
)
if !currIgnore!==1 (
	set currIgnore=TRUE
)
set mode=0
cls
Echo.
Echo Current mode:    !currMode!
Echo Ignore updates?: !currIgnore!
Echo ------------------------
Echo.
Echo Choose a mode:
Echo.
Echo 1 --^> Copy       ^(Copies the song to the Self Radio folder^)
Echo.
Echo 2 --^> Shortcut   ^(Creates a shortcut to the song in the Self Radio folder^)
Echo.
Echo.
Echo Ignore updates?
Echo.
Echo 3 --^> Yes        ^(Skips version checks^)
Echo.
Echo 4 --^> No         ^(Checks for version and displays a message if available^)
Echo.
Echo Settings can be changed later by running the program again.
Echo.
set /p mode=">> "
if !mode!==1 (
	:: Set mode to COPY
	set mode=COPY
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Mode" /d "!mode!" > nul
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"REG ADD: Access denied." ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	echo x=msgbox^("The mode has been successfully set to !mode!." ,64, "Success"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	goto :end
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	goto :eof
)
if !mode!==2 (
	:: Set mode to SHORTCUT
	set mode=SHORTCUT
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Mode" /d "!mode!" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	echo x=msgbox^("The mode has been successfully set to !mode!." ,64, "Success"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	goto :end
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	goto :eof
)
if !mode!==3 (
	:: Set IgnoreUpdates to TRUE
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Ignore" /d "1" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currMode!==UNDEFINED (
		goto menu
	)
	echo x=msgbox^("Ignore updates has been set to TRUE." ,64, "Success"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	goto :end0
)
if !mode!==4 (
	:: Set IgnoreUpdates to FALSE
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Ignore" /d "0" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currMode!==UNDEFINED (
		goto menu
	)
	echo x=msgbox^("Ignore updates has been set to FALSE." ,64, "Success"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	goto :end
)
goto :menu
:end
endlocal
exit